import 'package:flutter/cupertino.dart';
import 'package:taboola_sdk/publisher_info.dart';
import 'package:taboola_sdk/classic/taboola_classic.dart';
import 'package:taboola_sdk/classic/taboola_classic_listener.dart';
import 'package:taboola_sdk/classic/webview_manager.dart';
import 'package:taboola_sdk/classic/taboola_webview.dart';
import '../extra_properties_manager.dart';

class TaboolaClassicBuilder {
  /// Constructor
  TaboolaClassicBuilder(
    this._publisherInfo,
    this._extraPropertiesManager,
    this._pageUrl,
    this._pageType,
  );

  ExtraPropertiesManager _extraPropertiesManager;
  PublisherInfo _publisherInfo;
  String _pageUrl;
  String _pageType;

  /// Optional params
  String _pageId = "auto"; //default value
  String _targetType = "mix";

  /// Builder
  TaboolaClassicUnit build(
    String placement,
    String mode,
    bool isFeed,
    TaboolaClassicListener taboolaClassicListener, {
    int viewId,
    ScrollController scrollController,
  }) {
    if (_publisherInfo == null) {
      throw ('PublisherInfo is null, did you call Taboola init?');
    }

    return TaboolaClassicUnit(
      _extraPropertiesManager,
      _publisherInfo.publisherId,
      mode,
      placement,
      _pageUrl,
      _pageType,
      _pageId,
      _targetType,
      isFeed,
      taboolaClassicListener,
      viewId: viewId,
      scrollController: scrollController,
    );
  }
}
