library taboola;

import 'dart:collection';

import 'package:taboola_sdk/extra_properties_manager.dart';
import 'package:taboola_sdk/publisher_info.dart';
import 'package:taboola_sdk/classic/taboola_classic_builder.dart';
import 'package:taboola_sdk/utils/logger.dart';

export 'package:taboola_sdk/publisher_info.dart';
export 'package:taboola_sdk/classic/taboola_classic_builder.dart';

class Taboola {
  static PublisherInfo _publisherInfo;
  static ExtraPropertiesManager _extraPropertiesManager;

  static init(PublisherInfo publisherInfo,
      {HashMap<String, dynamic> extraProperties}) {
    _extraPropertiesManager = ExtraPropertiesManager(extraProperties);
    Taboola._publisherInfo = publisherInfo;
  }

  static TaboolaClassicBuilder getTaboolaClassicBuilder(
      String pageUrl, String pageType) {
    return new TaboolaClassicBuilder(
      _publisherInfo,
      _extraPropertiesManager,
      pageUrl,
      pageType,
    );
  }

  static void setLogsEnabled(bool enabled) {
    Logger.taboolaLogsEnabled = enabled;
  }
}
